//------------------------------------------------------------------------------
//      AT 8 
//  TIC149     PCF8535
//          
//        
//         
//       .
//    
//     10  +5
//    8   ,     0 
//  CPU       0

//      7812.5   
// 
//------------------------------------------------------------------------------
#include <avr/io.h>                 //  
#include <avr/iom32.h>              //  32
#include <avr/interrupt.h>          //   
#include <avr/pgmspace.h>           //   
#include <avr/eeprom.h>             //  
#include <avr/wdt.h>                // 
#include <util/delay.h>             // 

#include "bit.h"                    //   
#include "bin.h"                    //      
#include "main.h"                   //    
#include "dim.h"                    //   

#include "util.cpp"                 // 

//------------------------------------------------------------------------------
int main(void)
{
cli();                  //   
WDTCR=0xff;				//    2 
WDTCR=0xff;				//    2 
DDRB=8;					//    B 
DDRC=0;					//    C 
DDRD=0;					//    D 
PORTB=8;				//    B 
PORTC=0;				//    C 
PORTD=0;				//    D 
//******************************************************************************
//  / 0 (8- )
//  1  PB3/OC0 ???
// WGM01(CTC0)=1 WGM00(PWM0)=1    ,   
// COM01=1 COM00=1  +5v      
//        16 /8/256.
//  256   7812.5  CS02=0, CS01=1, CS00=0
TCCR0=(1<<WGM01)|(1<<WGM00)|(1<<COM01)|(1<<COM00)|(1<<CS01);
OCR0=0x80;		                //  50/50      
//   
TIMSK|=1<<TOIE0;	            //     0
//******************************************************************************
sei();                          //   

I2C_Init();
Logo();

while(true)				        //  
  {
  DOG;					        //  
  if(Changes)				    //     
    {
    Changes=false;			    //  
    Video();				    //       
    }
  if(DemoOn && f10)			    //       10 
    {
    f10=false;				    //   10 
    Clr(0x00);				    //  
    PrnWrd(0,0,DemoStage);		//   
    switch(DemoStage)
      {
      case 4:				    // 
        PrnSqr(20,16,90,44,2);
        PrnSqr(28,24,74,28,2);
        break;
      case 7:				    //   
        PrnP(60, 60, 1);		//   
        break;
      case 8:				    //   
        PrnP(40, 40, 1);		//   
        Line(90, 45, 2);		// 
        Line(95, 60, 2);		// 
        Line(35, 60, 2);		// 
        Line(40, 40, 2);		// 
        break;
      case 10:				    //   
        PrnWrd(0,6,20);			//   
        PrnWrdM(0,7,20);		//   
        break;
      case 13:				    //  
	ShiftScr(0x87);			    //   8 
        break;
      case 14:				    //   
        for(BYTE t=0; t<133; t++)V[7*133+t]=t;
	Changes=true;
        break;
      }
    DemoStage++;			    //  
    if(DemoStage>19)DemoStage=0;//    
    }
  }
}
//------------------------------------------------------------------------------
//       h/8/256=7812.5   
ISR(TIMER0_OVF_vect)
{
pSecs--;			// ..   1/10   781,25
if(!pSecs)			//       1
  {				    // 781,25=(781+781+781+782)/4
  pSecs=PSecs;		//  
  if(!(char(Secs)&3))pSecs++;	        //     =0    1
  Secs++;			//        1
  f01=true;			//   1/10 
  s1++; if(s1==10){s1=0; f1=true;}	    //   
  s10++; if(s10==100){s10=0; f10=true;}	//   10 
  }
}
//------------------------------------------------------------------------------
