//------------------------------------------------------------------------------
//      
//------------------------------------------------------------------------------
typedef unsigned char BYTE;         //    
typedef unsigned short WORD;        //   2  - 
typedef prog_uchar FBYTE;           //   FLASH 
typedef prog_char FCHAR;            //   FLASH 
//------------------------------------------------------------------------------
#define ERB  eeprom_read_byte       //    EEPROM
#define ERS  eeprom_read_block      //    EEPROM
#define EWB  eeprom_write_byte      //    EEPROM
#define EWS  eeprom_write_block     //    EEPROM
#define FRB  pgm_read_byte          //    FLASH
#define FRW  pgm_read_word          //    FLASH
#define FRS  memcpy_P               //    FLASH
#define RRS  memcpyR                //    RAM
//------------------------------------------------------------------------------
#define PAUSE0	_delay_us(0.6)	    //  
#define PAUSE1	_delay_us(1.2)	    //  
#define PAUSE2	_delay_us(10)       //  
#define DOG	wdt_reset()		        //  

//      
#define cmdReset	0	// 1 		  (C)
#define cmdBright	1	// 2 		  (C V)
#define cmdLight	2	// 2 		  (C V)
#define cmdSqr		3	// 6 		 (C Xo Yo W H COLOR)
#define cmdMirror	4	// 2 		 (C M)
#define cmdSleep	5	// 1		    (C)
#define cmdPoint	6	// 3		    (C X Y)
#define cmdLine		7	// 3		       (C X Y)
#define cmdPrint	8	// 4+N		      (C X Y N ...)
#define cmdFontChar	9	// 2+8		    (C Code BBBBBBBB)
#define cmdShift	10	// 2		  (C D)  
#define cmdBitmap	11	// 4+W		  (C X Y W  N B0 B1 B2 ...)
#define cmdLogo		12	// 1		  (C)
#define cmdAxi		13	// 7		  (C X Y W H ChX ChY)
#define cmdXY		14	// 3		   (C X Y)
#define cmdInvert	15	// 2		  (C Y)

#define cmdIncoming	255	    // 1      

//   (  )
#define scl		DDRD_Bit1	// Clock	 I2C
#define scl_in	PIND_Bit1	// ClockBusy	 
#define sda		DDRD_Bit0	// Data		 I2C
#define sda_in	PIND_Bit0	// DataAck	     
#define down	1		    //    ,   0,     
#define up		0		    //    ,     +,     
//------------------------------------------------------------------------------
volatile BYTE V[1064];		//  
                            //       
                            //   -, -.
bool Changes=false;		    //       
//------------------------------------------------------------------------------
volatile BYTE Cmd[100];		//   
volatile BYTE cCmd;			//       
volatile BYTE eCmd;			//   
//------------------------------------------------------------------------------
volatile BYTE MIRROR=0;		// b1 b0   
                            // 0 0 
                            // 0 1    x
                            // 1 0    y
                            // 1 1 
volatile BYTE X=0, Y=0;			    //    
//------------------------------------------------------------------------------
#define PSecs 	781		    // ClkFreq/8/256/10=781,25      1/10 .
volatile long Secs=0;		//   1/10 
volatile BYTE s1;			//  
volatile BYTE s10;			//   10 
volatile WORD pSecs=PSecs;	//    
volatile bool f01;			//    0.1 
volatile bool f1;			//    
volatile bool f10;			//    10 
//------------------------------------------------------------------------------
volatile bool DemoOn=true;	//   .      I2C:
                            // < 10 . 
                            // > 10 .     I2C (   )
volatile int DemoStage=0;	//  10     .
//------------------------------------------------------------------------------
