//------------------------------------------------------------------------------
void I2C_START(void)
{
scl=up;					//       (   )
while(!scl_in){DOG;}	//     , ..   
PAUSE1;					//     
sda=down;				//  
PAUSE0;					//      
scl=down;				//    ,      
PAUSE0;					//  
}
//------------------------------------------------------------------------------
void I2C_STOP(void)
{
// while(!sda_in){DOG;}	//       ACK ( )
PAUSE1;					//     
sda=down;				//     
scl=down;				//     
PAUSE1;					//  
scl=up;					//  
PAUSE1;					//  
sda=up;					//  ,  
PAUSE1;					//       +5
}
//------------------------------------------------------------------------------
//    I2C
bool I2C_WR(BYTE a)
{
bool ack=false;			//    
register BYTE i=8;		//    8 
while(i)				//  i  
  {					    //    
  i--;					//  i
  sda=!bool(a&128);		//      ,        
  PAUSE1;				//        
  scl=up;				//      ,    
  PAUSE0;				//       
  scl=down;				//    
  PAUSE1;				//                
  a<<=1;				//      
  }
                        //   ACK
sda=up;					//  
PAUSE1;					//    
scl=up;					//  ,      ACK   , ..   0
PAUSE1;					//    
ack=!sda_in;			//      
scl=down;				//  
PAUSE1;					//    
// while(!sda_in){DOG;}	//     , ..   
PAUSE1;					//   
return(ack);
}
//------------------------------------------------------------------------------
//    I2C
//           
//   -  
BYTE I2C_RD(void)
{
BYTE a=0;
register BYTE i=8;		//    8 
while(i)				//  i  
  {					    //    
  i--;					//  i
  PAUSE1;				//     
  scl=up;				//   ,    
  PAUSE0;				//      
  a<<=1;				//         
  if(sda_in)a|=1;		//   SDA      
  PAUSE0;				//       
  scl=down;				//    
  }
PAUSE0;					//    
return(a);				//    
}
//------------------------------------------------------------------------------
//    
void I2C_Init(void)
{
I2C_START();			//    
I2C_WR(0x78);			//    ( ) R/W=0    
I2C_WR(0x00);			//   Co=0, D/C=0    
I2C_WR(0x01);			//    "   "
I2C_WR(0x10);			// PD=0 -   "". V=0 -  
I2C_WR(0x20);			//      X
I2C_WR(0x40);			//   Y=0
I2C_WR(0x80);			//   X=0, ..     
I2C_WR(0x0E);			//    "  "
I2C_WR(0x12);			//   1/9 -      
I2C_WR(0x06);			// D=1 E=0 -      ( ...)
I2C_WR(0x08);			// MX MY
I2C_WR(0x84);			// 1:65    
I2C_WR(0x01);			//    "   "
I2C_WR(0x0D);			//   " "
I2C_WR(0x09);			//    = 3
I2C_WR(0x12);			//   2
I2C_WR(0xB0);			//  = 48
I2C_WR(0x05);			// HVE=1  , PRS=0   
I2C_STOP();				//   

PAUSE2;					//  ,   Vlcd 

I2C_START();			//    
I2C_WR(0x78);			//    ( ) R/W=0    
I2C_WR(0x00);			//   Co=0, D/C=0    
I2C_WR(0x01);			//    "   "
I2C_WR(0x0b);			//    
I2C_WR(0x58);			//   BRS=1 TRS=1 (  )
I2C_STOP();				//   
}
//------------------------------------------------------------------------------
//   (      )
BYTE MB(BYTE x)
{
return((x<<7)|((x<<5)&64)|((x<<3)&32)|((x<<1)&16)|((x>>1)&8)|((x>>3)&4)|((x>>5)&2)|(x>>7));
}
//------------------------------------------------------------------------------
//    
void Video(void)
{
I2C_START();			//    
I2C_WR(0x78);			//  .   .
I2C_WR(0x40);			// Co=0, D/C=1      
for(BYTE y=0; y<8; y++)
  for(BYTE x=0; x<133; x++)
    {
    switch(MIRROR&3)
      {
      case 0: I2C_WR(V[y*133+x]); break;		    //  
      case 1: I2C_WR(MB(V[(7-y)*133+x])); break;	//    X
      case 2: I2C_WR(V[y*133+132-x]); break;		//    Y
      case 3: I2C_WR(MB(V[(7-y)*133+132-x])); break;//  
      }
    }
I2C_STOP();			    //   
}
//------------------------------------------------------------------------------
//  
void Clr(BYTE c)
{
for(WORD a=0; a<1064; a++)V[a]=c;	//  "c" 
Changes=true;				        //   ,   !
}
//------------------------------------------------------------------------------
//   , 
void Logo(void)
{
WORD a=0;				    //     
BYTE f=0;				    // ,        
for(WORD i=0; i<851; i++)	//    
  {
  DOG;					    //  
  if(f>10)f=10;				//  
  if(f>1 && FRB(&PICT[i-2])==FRB(&PICT[i-1]))	//    (   )
    {
    for(WORD j=0; j<FRB(&PICT[i]); j++)V[a++]=FRB(&PICT[i-1]);	//    
    f=0;				    //     
    continue;				//      
    }
  V[a++]=FRB(&PICT[i]);		//           
  f++;					    //    
  }
Changes=true;				//   ,   !
}
//------------------------------------------------------------------------------
//    ""
void PrnP(BYTE x, BYTE y, BYTE c)
{
WORD a=x+(y>>3)*133;		//   
if(a>1063)return;			//      
switch(c)				    //   
  {
  case 0: V[a]&=~(1<<((~y)&7)); break;  //  
  case 1: V[a]|=1<<((~y)&7); break;	    //  
  case 2: V[a]^=1<<((~y)&7); break;	    // 
  }
X=x; Y=y;				    //   
Changes=true;				//   ,   !
}
//------------------------------------------------------------------------------
//  
void PrnSqr(BYTE x, BYTE y, BYTE w, BYTE h, BYTE c)
{
for(BYTE j=y; j<y+h; j++)
for(BYTE i=x; i<x+w; i++)
  PrnP(i, j, c);
Changes=true;				//   ,   !
}
//------------------------------------------------------------------------------
//     (  88 )
void PrnWrdM(BYTE x, BYTE y, BYTE n)
{
PGM_P sr=(PGM_P)(FRW(&(pDemo[n])));     //      FLASH
WORD a;					        //   
WORD ic;				        //     
BYTE ix;				        //     
BYTE c;					        //   
bool f=false;				    //   
do{                             //    
  c=FRB(sr++);                  //  
  if(!c)break;				    //    ,  
  if(f && c==' '){f=false; continue;}	    //      ,    
  f=false;				        //   
  if(c=='\n'){y++; x=0; f=true; continue;}  //   
  if(x>16){y++; x=0;}			//   
  if(y>7)break;				    //   y
  ix=x<<3;				        //   
  a=ix+y*133;				    //      
  ic=(c-32)<<3;				    //     
  for(BYTE j=0; j<8; j++)		//    
    {
    if(ix+j>132)break;			//        	
    V[a+j]=FRB(&FONT[ic+j]);	//     
    }
  x++;					        //    
  if(x>15){x=0; y++; if(y>7)break;}	        //   ,   
  }while(true);
Changes=true;				    //   ,   !
}
//------------------------------------------------------------------------------
//      ( N8 )
void PrnWrd(BYTE x, BYTE y, BYTE n)
{
PGM_P sr=(PGM_P)(FRW(&(pDemo[n])));         //      FLASH
WORD a, a2;				//    ,   
WORD ic;				//     
BYTE jj;				//      
BYTE c;					//   
bool f=false;				//   
if(x>16)return;				//   
if(y>7)return;				//   y
a=(x<<3)+y*133;				//      
a2=y*133+132;				//   
do{
  if(a>1063)break;			//     ,  .
  c=FRB(sr++);              //  
  if(!c)break;				//    ,  
  ic=(c-32)<<3;				//     
  for(jj=7; jj>2; jj--)		//      
    if(FRB(&FONT[ic+jj])!=0)break;    // jj -  
  if(a+jj>a2 || c=='\n')	//           
    {
    y++;				    //    
    if(y>7)break;			//    
    f=true;				    //   
    a=y*133;				//    
    a2=y*133+132;			//    
    }
  if(f && (c==' ' || c=='\n')){f=false; continue;}//      ,    
  f=false;
  for(BYTE j=0; j<=jj; j++)	//    
    {
    if(a>1063)break;		//     ,  .	
    V[a]=FRB(&FONT[ic+j]);	//     
    a++;
    }
  if(a>1063)break;			//     ,  .
  V[a]=0; a++;				//    
  }while(true);
Changes=true;				//   ,   !
}
//------------------------------------------------------------------------------
//    ""
void Line(BYTE x, BYTE y, BYTE c)
{
BYTE p1;				//  
BYTE p2;				//  
float k=float(y-Y)/(x-X);		//   
float a;				// 
if(k<0)k=-k;				//   
if(k<1)
  {
  k=float(y-Y)/(x-X);			//   
  a=y-float(k*x);			//   
  p1=x<X?x:X;				//    
  p2=x<X?X:x;				//    
  for(BYTE i=p1; i<=p2; i++)		//    
    {
    BYTE j=int(a+k*i);			//   
    PrnP(i, j, c);			//  
    }
  }
else
  {
  k=float(x-X)/(y-Y);			//   
  a=x-float(k*y);			//   
  p1=y<Y?y:Y;				//    
  p2=y<Y?Y:y;				//    
  for(BYTE i=p1; i<=p2; i++)		//    
    {
    BYTE j=int(a+k*i);			//   
    PrnP(j, i, c);			//  
    }
  }

X=x; Y=y;				//   
}
//------------------------------------------------------------------------------
//      8 
// b7,b6 -  00-, 01-, 10-, 11-
// b5 -  0-, 1-
// b2,b1,b0    1  8 
void ShiftScr(BYTE d)
{
BYTE x, y, i, n=(d&7)+1;		//      
bool f=d&32;				// 0-, 1- 
WORD a;					//   
BYTE t;					//      
switch(d>>6)				//     
  {
  case 0:				// 
    for(x=0; x<133; x++)		//    
      {
      t=V[x]>>(8-n);			//           t
      for(y=0; y<7; y++)		//     
        {
	a=x+y*133;			//   
	V[a]=(V[a]<<n)|(V[a+133]>>(8-n));//       
	}
      a+=133;				//      
      V[a]<<=n;				//   
      if(f)V[a]|=t;			//  ,   ,     
      }
    break;
  case 1:				// 
    for(y=0; y<8; y++)			//    
      {
      WORD a1=y*133;			//    
      WORD a2=a1+132;			//    
      BYTE T[8]; for(i=0; i<n; i++)T[i]=V[a2-i];		//      
      for(x=0; x<133-n; x++)V[a2-x]=V[a2-x-n];			//     
      for(i=0; i<n; i++)if(f)V[a1+i]=T[n-i-1]; else V[a1+i]=0;	//  
      }
    break;
  case 2:				// 
    for(x=0; x<133; x++)		//    
      {
      t=V[x+7*133]<<(8-n);		//           t
      for(y=7; y>0; y--)		//     
        {
	a=x+y*133;			//   
	V[a]=(V[a]>>n)|(V[a-133]<<(8-n));//       
	}
      V[x]>>=n;				//      
      if(f)V[x]|=t;			//  ,   ,     
      }
    break;
  case 3:				// 
    for(y=0; y<8; y++)			//    
      {
      WORD a1=y*133;			//    
      WORD a2=a1+132;			//    
      BYTE T[8]; for(i=0; i<n; i++)T[i]=V[a1+i];			//      
      for(x=0; x<133-n; x++)V[a1+x]=V[a1+x+n];				//     
      for(i=0; i<n; i++)if(f)V[a2-n+1+i]=T[i]; else V[a2-n+1+i]=0;	//  
      }
    break;
  }
Changes=true;				//   ,   !
}
//------------------------------------------------------------------------------
void SetLight(BYTE x)
{
OCR0=~x;
}
//------------------------------------------------------------------------------
void SetVoltage(BYTE x)
{
PAUSE2;					//  
I2C_START();				//    
I2C_WR(0x78);				//    ( ) R/W=0    
I2C_WR(0x00);				//   Co=0, D/C=0    
I2C_WR(0x01);				//    "   "
I2C_WR(0x0D);				//   " "
I2C_WR(0x09);				//    = 3
I2C_WR(0x12);				//   2
if(x&0x80)
  {
  x&=0x7f;				//   
  I2C_WR(0x80|x);			//  = 48
  I2C_WR(0x07);				// HVE=1  , PRS=1   
  }
else
  {
  x&=0x7f;				//   
  I2C_WR(0x80|x);			//  = 48
  I2C_WR(0x05);				// HVE=1  , PRS=0   
  }
I2C_STOP();				//   
}
//------------------------------------------------------------------------------
